
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

//
//
//
//
//

#include <stdlib.mqh>

//
//
//
//
//

extern string Name_Expert            = "Dss Ichi2";
extern bool   EcnBroker              = true;
extern string SymbolsPrefix          = "";
extern string SymbolsSuffix          = "";
extern bool   UseAutoMagic           = true;
extern int    ManualMagic            = 82828282;  
extern double lStopLoss              = 100;
extern double sStopLoss              = 100;
extern double lTakeProfit            = 100;
extern double sTakeProfit            = 100;
extern double lTrailingStop          = 50;
extern double sTrailingStop          = 50;
extern int    Slippage               = 4;
extern double Lots                   = 0.1;
extern double MaximumRisk            = 0;
extern double DecreaseFactor         = 3;

extern int    Tenkan                 = 9;
extern int    Kijun                  = 26;
extern int    Senkou                 = 52;
extern int    ChinkouShift           = -26;
extern int    Tenkan2                = 9;
extern int    Kijun2                 = 26;
extern int    Senkou2                = 52;
extern int    ChinkouShift2          = -26;
extern int    ichTf                  = 5;
extern int    ichTf2                 = 240;

extern int    Stochastic.Period      = 50;
extern int    Ema.Smoothing.Period   = 15;
extern double Up.Level               = 80;
extern double Dn.Level               = 20;
extern int    bar                    = 1;

extern bool   UseStochClose          = true;
extern int    clStochastic.Period    = 50;
extern int    clEma.Smoothing.Period = 15;
extern double clUp.Level             = 80;
extern double clDn.Level             = 20;
extern int    clbar                  = 1;

extern bool   UseHourTrade           = false;
extern int    FromHourTrade          = 8;
extern int    ToHourTrade            = 19;

extern bool   ShowAlerts             = false;
extern color  clOpenBuy              = Blue;
extern color  clCloseBuy             = Aqua;
extern color  clOpenSell             = Red;
extern color  clCloseSell            = Violet;

//
//
//
//
//

double pipMultiplier = 1;
string s_symbol;
int    MAGIC;

//
//
//
//
//

int init() 
{
  s_symbol = Symbol();
  if (UseAutoMagic) MAGIC = GetMagic();
              else  MAGIC = ManualMagic;  
              
return(0);
}

//
//
//
//
//

int deinit() { Comment(""); return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   if (Digits == 3 || Digits == 5) 
         pipMultiplier = 10;
   else  pipMultiplier = 1;  
   
   //
   //
   //
   //
   //
   
   if(Bars < 100) { Print("bars less than 100"); return(0); }
   
   //
   //
   //
   //
   //
   
   if (UseHourTrade)
   {
     if(!(Hour() >= FromHourTrade && Hour() <= ToHourTrade)) { Comment("Non-Trading Hours!");  return(0);  }
   }
   
   //
   //
   //
   //
   //
   
   if(lStopLoss   < 10) {  Print("StopLoss less than 10");   return(0);  }
   if(lTakeProfit < 10) {  Print("TakeProfit less than 10"); return(0);  }
   if(sStopLoss   < 10) {  Print("StopLoss less than 10");   return(0);  }
   if(sTakeProfit < 10) {  Print("TakeProfit less than 10"); return(0);  }
   
   //
   //
   //
   //
   //
   
   double tenkancur    = iCustom(s_symbol,ichTf,"Ichimoku2", Tenkan, Kijun, Senkou, ChinkouShift,0,bar);
   double kijuncur     = iCustom(s_symbol,ichTf,"Ichimoku2", Tenkan, Kijun, Senkou, ChinkouShift,1,bar);
   double senkouspana  = iCustom(s_symbol,ichTf,"Ichimoku2", Tenkan, Kijun, Senkou, ChinkouShift,2,bar+Kijun);
   double senkouspanb  = iCustom(s_symbol,ichTf,"Ichimoku2", Tenkan, Kijun, Senkou, ChinkouShift,3,bar+Kijun);
   double tenkancur2   = iCustom(s_symbol,ichTf2,"Ichimoku2",Tenkan2,Kijun2,Senkou2,ChinkouShift2,0,bar);
   double kijuncur2    = iCustom(s_symbol,ichTf2,"Ichimoku2",Tenkan2,Kijun2,Senkou2,ChinkouShift2,1,bar);
   double senkouspana2 = iCustom(s_symbol,ichTf2,"Ichimoku2",Tenkan2,Kijun2,Senkou2,ChinkouShift2,2,bar+Kijun);
   double senkouspanb2 = iCustom(s_symbol,ichTf2,"Ichimoku2",Tenkan2,Kijun2,Senkou2,ChinkouShift2,3,bar+Kijun);
   
   double stonow = iCustom(s_symbol,0,"Double smoothed stochastic 2",Stochastic.Period,Ema.Smoothing.Period,0,bar);
   double stopre = iCustom(s_symbol,0,"Double smoothed stochastic 2",Stochastic.Period,Ema.Smoothing.Period,0,bar+1);
   
   
 
   if (!ExistPositions())
   {
      
      if (tenkancur  > MathMax(senkouspana,senkouspanb)   && kijuncur  > MathMax(senkouspana,senkouspanb)   && tenkancur  > kijuncur  &&
          tenkancur2 > MathMax(senkouspana2,senkouspanb2) && kijuncur2 > MathMax(senkouspana2,senkouspanb2) && tenkancur2 > kijuncur2 && stonow > stopre && stonow >= Dn.Level && stopre < Dn.Level) 
      {
         OpenBuy();
         return(0);
      }

      if (tenkancur  < MathMin(senkouspana,senkouspanb)   && kijuncur  < MathMin(senkouspana,senkouspanb)   && tenkancur  < kijuncur  &&
          tenkancur2 < MathMin(senkouspana2,senkouspanb2) && kijuncur2 < MathMin(senkouspana2,senkouspanb2) && tenkancur2 < kijuncur2 && stonow < stopre && stonow <= Up.Level && stopre > Up.Level) 
      {
         OpenSell();
         return(0);
      }
      
   
   }
   
   TrailingPositionsBuy(lTrailingStop);
   TrailingPositionsSell(sTrailingStop);
   if(UseStochClose)   CheckForClose();
   
   return (0);
}

//
//
//
//
//

bool ExistPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) {
				return(true);
			}
		} 
	} 
	return(false);
}

//
//
//
//
//

void TrailingPositionsBuy(int trailingStop) { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_BUY) { 
               if (Bid-OrderOpenPrice()     > trailingStop * Point * pipMultiplier) { 
                  if (OrderStopLoss() < Bid - trailingStop * Point * pipMultiplier) 
                      ModifyStopLoss(Bid    - trailingStop * Point * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void TrailingPositionsSell(int trailingStop) { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_SELL) { 
               if (OrderOpenPrice() - Ask   > trailingStop * Point * pipMultiplier) { 
                  if (OrderStopLoss() > Ask + trailingStop * Point * pipMultiplier || OrderStopLoss() == 0)  
                      ModifyStopLoss(Ask    + trailingStop * Point * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void ModifyStopLoss(double ldStopLoss) 
{ 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE); 
   
   if (fm == false)
   {
	  int    ErrorCode = GetLastError();
	  string ErrDesc   = ErrorDescription(ErrorCode);

	  string ErrAlert  = StringConcatenate("Trailing Stop Modification - Error ",ErrorCode,": ",ErrDesc);
	  if (ShowAlerts   == true) Alert(ErrAlert);

	  string ErrLog    = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss()," Trail: ",ldStopLoss);
	  Print(ErrLog);
	}
 
} 

//
//
//
//
//

void OpenBuy() 
{ 
    
   double lbStop = GetStopLossBuy(); 
   double lbTake = GetTakeProfitBuy();
   
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker) 
         OrderSend(s_symbol,OP_BUY,LotsOptimized(),Ask,Slippage*Point*pipMultiplier,lbStop,lbTake,Name_Expert,MAGIC,0,clOpenBuy); 
   else
   {
         int buyTicket    = OrderSend(s_symbol,OP_BUY,LotsOptimized(),Ask,Slippage*Point*pipMultiplier,0,0,Name_Expert,MAGIC,0,clOpenBuy);		    		    
         if (buyTicket   >= 0)
         bool buyOrderMod = OrderModify(buyTicket,OrderOpenPrice(),lbStop,lbTake,0,CLR_NONE);
         
         if (buyOrderMod  == false)
         {
         
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Buy Order - Error ",ErrorCode,": ",ErrDesc);
           if (ShowAlerts   == true) Alert(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",Ask," Bid: ",Bid," Ticket: ",buyTicket," Stop: ",lbStop," Profit: ",lbTake);
           Print(ErrLog);
         }
    }		       

}

//
//
//
//
//

void OpenSell() 
{ 

   double lsStop = GetStopLossSell(); 
   double lsTake = GetTakeProfitSell();
  
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker)
         OrderSend(s_symbol,OP_SELL,LotsOptimized(),Bid,Slippage*Point*pipMultiplier,lsStop,lsTake,Name_Expert,MAGIC,0,clOpenSell); 
   else
   {
         int sellTicket    = OrderSend(s_symbol,OP_SELL,LotsOptimized(),Bid,Slippage*Point*pipMultiplier,0,0,Name_Expert,MAGIC,0,clOpenSell);		    		    
         if (sellTicket    >= 0)
         bool sellOrderMod = OrderModify(sellTicket,OrderOpenPrice(),lsStop,lsTake,0,CLR_NONE);
         
         if (sellOrderMod  == false)
         {
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Sell Order - Error ",ErrorCode,": ",ErrDesc);
           if (ShowAlerts   == true) Alert(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",Ask," Bid: ",Bid," Ticket: ",sellTicket," Stop: ",lsStop," Profit: ",lsTake);
           Print(ErrLog);
          }
    }		       
} 

//
//
//
//
//

void CheckForClose()  
{
   RefreshRates();
   double clstonow = iCustom(s_symbol,0,"Double smoothed stochastic 2",clStochastic.Period,clEma.Smoothing.Period,0,clbar);
   double clstopre = iCustom(s_symbol,0,"Double smoothed stochastic 2",clStochastic.Period,clEma.Smoothing.Period,0,clbar+1);
   
   //
   //
   //
   //
   //
   
   for (int i = 0;i < OrdersTotal(); i++)
   {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false)  break;
      if (OrderMagicNumber()!= MAGIC)                         continue;
      if (OrderSymbol()     != s_symbol)                      continue;
      
      //
      //
      //
      //
      //
      
      if (OrderType() == OP_BUY)
      {
        if (clstonow < clstopre && clstonow <= clUp.Level && clstopre > clUp.Level) 
        {
           bool buyClose = OrderClose(OrderTicket(),OrderLots(),Bid,Slippage*Point*pipMultiplier,clCloseBuy);
           if (buyClose == false)
           {
             int ErrorCode   = GetLastError();
             string ErrDesc  = ErrorDescription(ErrorCode);

             string ErrAlert = StringConcatenate("Close Buy Order - Error ",ErrorCode,": ",ErrDesc);
             if (ShowAlerts  == true) Alert(ErrAlert);

             string ErrLog   = StringConcatenate("Bid: ",Bid," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
             Print(ErrLog);
           }
        }
        break;
      }
      
      //
      //
      //
      //
      //
        
      if (OrderType() == OP_SELL)
      {
        if (clstonow > clstopre && clstonow >= clDn.Level && clstopre < clDn.Level) 
        {
          bool sellClose = OrderClose(OrderTicket(),OrderLots(),Ask,Slippage*Point*pipMultiplier,clCloseSell); 
          if (sellClose  == false)
          {
             ErrorCode = GetLastError();
             ErrDesc   = ErrorDescription(ErrorCode);

             ErrAlert  = StringConcatenate("Close Sell Order - Error ",ErrorCode,": ",ErrDesc);
             if (ShowAlerts == true) Alert(ErrAlert);

             ErrLog   = StringConcatenate("Ask: ",Ask," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
             Print(ErrLog);
          }
        }
        break;
      }
   }
}

//
//
//
//
//

double GetStopLossBuy()    { 	return(Bid - lStopLoss   * Point * pipMultiplier); } 
double GetStopLossSell()   { 	return(Ask + sStopLoss   * Point * pipMultiplier); } 
double GetTakeProfitBuy()  { 	return(Ask + lTakeProfit * Point * pipMultiplier); } 
double GetTakeProfitSell() { 	return(Bid - sTakeProfit * Point * pipMultiplier); } 

//
//
//
//
//

double LotsOptimized()
{
   double lot_min  = MarketInfo(s_symbol,MODE_MINLOT);
   double lot_max  = MarketInfo(s_symbol,MODE_MAXLOT);
   double lot_step = MarketInfo(s_symbol,MODE_LOTSTEP);
   double contract = MarketInfo(s_symbol,MODE_LOTSIZE);
   double lot      = Lots;
   int    orders   = HistoryTotal();     // history orders total
   int    losses   = 0;                  // number of losses orders without a break
   
   //
   //
   //
   //
   //
   
   if(lot_min < 0.0 || lot_max <= 0.0 || lot_step <= 0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage()<=0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   if (MaximumRisk > 0)
   {
   lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk * AccountLeverage()/contract,2);
   }
   
   if(DecreaseFactor>0)
   {
      for(int i=orders-1;i>=0;i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
      if(OrderSymbol()!= s_symbol || OrderType() > OP_SELL) continue;
      
      //
      //
      //
      //
      //
      
      if(OrderProfit() > 0) break;
      if(OrderProfit() < 0) losses++;
      }
   if(losses>1) lot=NormalizeDouble(lot - lot * losses/DecreaseFactor,2);
   }
   
   //
   //
   //
   //
   //
   
   lot=NormalizeDouble(lot/lot_step,0)*lot_step;
   if(lot<lot_min) lot=lot_min;
   if(lot>lot_max) lot=lot_max;
   
   //
   //
   //
   //
   //
   
   return(lot);
} 

//
//
//
//
//

int GetMagic() 
{

   if (s_symbol == SymbolsPrefix+"CADJPY"+SymbolsSuffix) return(91922921);
   if (s_symbol == SymbolsPrefix+"CADCHF"+SymbolsSuffix) return(91922922);
   
   if (s_symbol == SymbolsPrefix+"GOLD"  +SymbolsSuffix) return(91922931);
   if (s_symbol == SymbolsPrefix+"SILVER"+SymbolsSuffix) return(91922932);
   
   if (s_symbol == SymbolsPrefix+"NZDJPY"+SymbolsSuffix) return(91922941);
   if (s_symbol == SymbolsPrefix+"NZDUSD"+SymbolsSuffix) return(91922942);
   
   if (s_symbol == SymbolsPrefix+"CHFJPY"+SymbolsSuffix) return(91922951);
   
   if (s_symbol == SymbolsPrefix+"EURAUD"+SymbolsSuffix) return(91922961);
   if (s_symbol == SymbolsPrefix+"EURCAD"+SymbolsSuffix) return(91922962);
   if (s_symbol == SymbolsPrefix+"EURUSD"+SymbolsSuffix) return(91922963);
   if (s_symbol == SymbolsPrefix+"EURGBP"+SymbolsSuffix) return(91922964);
   if (s_symbol == SymbolsPrefix+"EURCHF"+SymbolsSuffix) return(91922965);
   if (s_symbol == SymbolsPrefix+"EURNZD"+SymbolsSuffix) return(91922966);
   if (s_symbol == SymbolsPrefix+"EURJPY"+SymbolsSuffix) return(91922967);
   
   if (s_symbol == SymbolsPrefix+"GBPUSD"+SymbolsSuffix) return(91922971);
   if (s_symbol == SymbolsPrefix+"GBPCHF"+SymbolsSuffix) return(91922972);
   if (s_symbol == SymbolsPrefix+"GBPJPY"+SymbolsSuffix) return(91922973);
   
   if (s_symbol == SymbolsPrefix+"USDCHF"+SymbolsSuffix) return(91922981);
   if (s_symbol == SymbolsPrefix+"USDJPY"+SymbolsSuffix) return(91922982);
   if (s_symbol == SymbolsPrefix+"USDCAD"+SymbolsSuffix) return(91922983);

   if (s_symbol == SymbolsPrefix+"AUDUSD"+SymbolsSuffix) return(91922991);
   if (s_symbol == SymbolsPrefix+"AUDNZD"+SymbolsSuffix) return(91922992);
   if (s_symbol == SymbolsPrefix+"AUDCAD"+SymbolsSuffix) return(91922993);
   if (s_symbol == SymbolsPrefix+"AUDCHF"+SymbolsSuffix) return(91922994);
   if (s_symbol == SymbolsPrefix+"AUDJPY"+SymbolsSuffix) return(91922295);
   
   return(ManualMagic);
}



